/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.foundation.core.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.Activity_graphsPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.Partition;
import fr.obeo.acceleo.uml13.behavioral_elements.collaborations.ClassifierRole;
import fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Collaboration;
import fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateMachine;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.Comment;
import fr.obeo.acceleo.uml13.foundation.core.Constraint;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Dependency;
import fr.obeo.acceleo.uml13.foundation.core.ElementResidence;
import fr.obeo.acceleo.uml13.foundation.core.Flow;
import fr.obeo.acceleo.uml13.foundation.core.ModelElement;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.core.PresentationElement;
import fr.obeo.acceleo.uml13.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.TaggedValue;
import fr.obeo.acceleo.uml13.model_management.ElementImport;
import fr.obeo.acceleo.uml13.model_management.Model_managementPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Model Element</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getElementImport <em>Element Import</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getName <em>Name</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getVisibility <em>Visibility</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#isIsSpecification <em>Is Specification</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getNamespace <em>Namespace</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getClientDependency <em>Client Dependency</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getConstraint <em>Constraint</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getSupplierDependency <em>Supplier Dependency</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getPresentation <em>Presentation</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getTargetFlow <em>Target Flow</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getSourceFlow <em>Source Flow</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getTemplateParameter3 <em>Template Parameter3</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getBinding <em>Binding</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getComment <em>Comment</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getElementResidence <em>Element Residence</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getTemplateParameter <em>Template Parameter</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getTemplateParameter2 <em>Template Parameter2</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getStereotype <em>Stereotype</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getTaggedValue <em>Tagged Value</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getBehavior <em>Behavior</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getClassifierRole <em>Classifier Role</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getCollaboration <em>Collaboration</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl#getPartition <em>Partition</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class ModelElementImpl extends ElementImpl implements ModelElement {
	/**
	 * The cached value of the '{@link #getElementImport() <em>Element Import</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getElementImport()
	 * @generated
	 * @ordered
	 */
	protected EList elementImport = null;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getVisibility() <em>Visibility</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getVisibility()
	 * @generated
	 * @ordered
	 */
	protected static final String VISIBILITY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getVisibility() <em>Visibility</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getVisibility()
	 * @generated
	 * @ordered
	 */
	protected String visibility = VISIBILITY_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsSpecification() <em>Is Specification</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsSpecification()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_SPECIFICATION_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsSpecification() <em>Is Specification</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsSpecification()
	 * @generated
	 * @ordered
	 */
	protected boolean isSpecification = IS_SPECIFICATION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getClientDependency() <em>Client Dependency</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getClientDependency()
	 * @generated
	 * @ordered
	 */
	protected EList clientDependency = null;

	/**
	 * The cached value of the '{@link #getConstraint() <em>Constraint</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getConstraint()
	 * @generated
	 * @ordered
	 */
	protected EList constraint = null;

	/**
	 * The cached value of the '{@link #getSupplierDependency() <em>Supplier Dependency</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSupplierDependency()
	 * @generated
	 * @ordered
	 */
	protected EList supplierDependency = null;

	/**
	 * The cached value of the '{@link #getPresentation() <em>Presentation</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getPresentation()
	 * @generated
	 * @ordered
	 */
	protected EList presentation = null;

	/**
	 * The cached value of the '{@link #getTargetFlow() <em>Target Flow</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTargetFlow()
	 * @generated
	 * @ordered
	 */
	protected EList targetFlow = null;

	/**
	 * The cached value of the '{@link #getSourceFlow() <em>Source Flow</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSourceFlow()
	 * @generated
	 * @ordered
	 */
	protected EList sourceFlow = null;

	/**
	 * The cached value of the '{@link #getTemplateParameter3() <em>Template Parameter3</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTemplateParameter3()
	 * @generated
	 * @ordered
	 */
	protected EList templateParameter3 = null;

	/**
	 * The cached value of the '{@link #getBinding() <em>Binding</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getBinding()
	 * @generated
	 * @ordered
	 */
	protected Binding binding = null;

	/**
	 * The cached value of the '{@link #getComment() <em>Comment</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getComment()
	 * @generated
	 * @ordered
	 */
	protected EList comment = null;

	/**
	 * The cached value of the '{@link #getElementResidence() <em>Element Residence</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getElementResidence()
	 * @generated
	 * @ordered
	 */
	protected EList elementResidence = null;

	/**
	 * The cached value of the '{@link #getTemplateParameter() <em>Template Parameter</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTemplateParameter()
	 * @generated
	 * @ordered
	 */
	protected EList templateParameter = null;

	/**
	 * The cached value of the '{@link #getTemplateParameter2() <em>Template Parameter2</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTemplateParameter2()
	 * @generated
	 * @ordered
	 */
	protected EList templateParameter2 = null;

	/**
	 * The cached value of the '{@link #getStereotype() <em>Stereotype</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStereotype()
	 * @generated
	 * @ordered
	 */
	protected Stereotype stereotype = null;

	/**
	 * The cached value of the '{@link #getTaggedValue() <em>Tagged Value</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTaggedValue()
	 * @generated
	 * @ordered
	 */
	protected EList taggedValue = null;

	/**
	 * The cached value of the '{@link #getBehavior() <em>Behavior</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getBehavior()
	 * @generated
	 * @ordered
	 */
	protected EList behavior = null;

	/**
	 * The cached value of the '{@link #getClassifierRole() <em>Classifier Role</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getClassifierRole()
	 * @generated
	 * @ordered
	 */
	protected EList classifierRole = null;

	/**
	 * The cached value of the '{@link #getCollaboration() <em>Collaboration</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getCollaboration()
	 * @generated
	 * @ordered
	 */
	protected EList collaboration = null;

	/**
	 * The cached value of the '{@link #getPartition() <em>Partition</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getPartition()
	 * @generated
	 * @ordered
	 */
	protected EList partition = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ModelElementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CorePackage.eINSTANCE.getModelElement();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getElementImport() {
		if (elementImport == null) {
			elementImport = new EObjectWithInverseResolvingEList(ElementImport.class, this, CorePackage.MODEL_ELEMENT__ELEMENT_IMPORT, Model_managementPackage.ELEMENT_IMPORT__MODEL_ELEMENT);
		}
		return elementImport;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.MODEL_ELEMENT__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getVisibility() {
		return visibility;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setVisibility(String newVisibility) {
		String oldVisibility = visibility;
		visibility = newVisibility;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.MODEL_ELEMENT__VISIBILITY, oldVisibility, visibility));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isIsSpecification() {
		return isSpecification;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIsSpecification(boolean newIsSpecification) {
		boolean oldIsSpecification = isSpecification;
		isSpecification = newIsSpecification;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.MODEL_ELEMENT__IS_SPECIFICATION, oldIsSpecification, isSpecification));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Namespace getNamespace() {
		if (eContainerFeatureID != CorePackage.MODEL_ELEMENT__NAMESPACE)
			return null;
		return (Namespace) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setNamespace(Namespace newNamespace) {
		if (newNamespace != eContainer || (eContainerFeatureID != CorePackage.MODEL_ELEMENT__NAMESPACE && newNamespace != null)) {
			if (EcoreUtil.isAncestor(this, newNamespace))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newNamespace != null)
				msgs = ((InternalEObject) newNamespace).eInverseAdd(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newNamespace, CorePackage.MODEL_ELEMENT__NAMESPACE, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.MODEL_ELEMENT__NAMESPACE, newNamespace, newNamespace));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getClientDependency() {
		if (clientDependency == null) {
			clientDependency = new EObjectWithInverseResolvingEList.ManyInverse(Dependency.class, this, CorePackage.MODEL_ELEMENT__CLIENT_DEPENDENCY, CorePackage.DEPENDENCY__CLIENT);
		}
		return clientDependency;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getConstraint() {
		if (constraint == null) {
			constraint = new EObjectWithInverseResolvingEList.ManyInverse(Constraint.class, this, CorePackage.MODEL_ELEMENT__CONSTRAINT, CorePackage.CONSTRAINT__CONSTRAINED_ELEMENT);
		}
		return constraint;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getSupplierDependency() {
		if (supplierDependency == null) {
			supplierDependency = new EObjectWithInverseResolvingEList.ManyInverse(Dependency.class, this, CorePackage.MODEL_ELEMENT__SUPPLIER_DEPENDENCY, CorePackage.DEPENDENCY__SUPPLIER);
		}
		return supplierDependency;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getPresentation() {
		if (presentation == null) {
			presentation = new EObjectWithInverseResolvingEList.ManyInverse(PresentationElement.class, this, CorePackage.MODEL_ELEMENT__PRESENTATION, CorePackage.PRESENTATION_ELEMENT__SUBJECT);
		}
		return presentation;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getTargetFlow() {
		if (targetFlow == null) {
			targetFlow = new EObjectWithInverseResolvingEList.ManyInverse(Flow.class, this, CorePackage.MODEL_ELEMENT__TARGET_FLOW, CorePackage.FLOW__TARGET);
		}
		return targetFlow;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getSourceFlow() {
		if (sourceFlow == null) {
			sourceFlow = new EObjectWithInverseResolvingEList.ManyInverse(Flow.class, this, CorePackage.MODEL_ELEMENT__SOURCE_FLOW, CorePackage.FLOW__SOURCE);
		}
		return sourceFlow;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getTemplateParameter3() {
		if (templateParameter3 == null) {
			templateParameter3 = new EObjectWithInverseResolvingEList(TemplateParameter.class, this, CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER3, CorePackage.TEMPLATE_PARAMETER__DEFAULT_ELEMENT);
		}
		return templateParameter3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Binding getBinding() {
		if (binding != null && binding.eIsProxy()) {
			Binding oldBinding = binding;
			binding = (Binding) eResolveProxy((InternalEObject) binding);
			if (binding != oldBinding) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CorePackage.MODEL_ELEMENT__BINDING, oldBinding, binding));
			}
		}
		return binding;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Binding basicGetBinding() {
		return binding;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetBinding(Binding newBinding, NotificationChain msgs) {
		Binding oldBinding = binding;
		binding = newBinding;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CorePackage.MODEL_ELEMENT__BINDING, oldBinding, newBinding);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setBinding(Binding newBinding) {
		if (newBinding != binding) {
			NotificationChain msgs = null;
			if (binding != null)
				msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
			if (newBinding != null)
				msgs = ((InternalEObject) newBinding).eInverseAdd(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
			msgs = basicSetBinding(newBinding, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.MODEL_ELEMENT__BINDING, newBinding, newBinding));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getComment() {
		if (comment == null) {
			comment = new EObjectWithInverseResolvingEList.ManyInverse(Comment.class, this, CorePackage.MODEL_ELEMENT__COMMENT, CorePackage.COMMENT__ANNOTATED_ELEMENT);
		}
		return comment;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getElementResidence() {
		if (elementResidence == null) {
			elementResidence = new EObjectWithInverseResolvingEList(ElementResidence.class, this, CorePackage.MODEL_ELEMENT__ELEMENT_RESIDENCE, CorePackage.ELEMENT_RESIDENCE__RESIDENT);
		}
		return elementResidence;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getTemplateParameter() {
		if (templateParameter == null) {
			templateParameter = new EObjectContainmentWithInverseEList(TemplateParameter.class, this, CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER, CorePackage.TEMPLATE_PARAMETER__MODEL_ELEMENT);
		}
		return templateParameter;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getTemplateParameter2() {
		if (templateParameter2 == null) {
			templateParameter2 = new EObjectWithInverseResolvingEList(TemplateParameter.class, this, CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER2, CorePackage.TEMPLATE_PARAMETER__MODEL_ELEMENT2);
		}
		return templateParameter2;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Stereotype getStereotype() {
		if (stereotype != null && stereotype.eIsProxy()) {
			Stereotype oldStereotype = stereotype;
			stereotype = (Stereotype) eResolveProxy((InternalEObject) stereotype);
			if (stereotype != oldStereotype) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CorePackage.MODEL_ELEMENT__STEREOTYPE, oldStereotype, stereotype));
			}
		}
		return stereotype;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Stereotype basicGetStereotype() {
		return stereotype;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetStereotype(Stereotype newStereotype, NotificationChain msgs) {
		Stereotype oldStereotype = stereotype;
		stereotype = newStereotype;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CorePackage.MODEL_ELEMENT__STEREOTYPE, oldStereotype, newStereotype);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setStereotype(Stereotype newStereotype) {
		if (newStereotype != stereotype) {
			NotificationChain msgs = null;
			if (stereotype != null)
				msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
			if (newStereotype != null)
				msgs = ((InternalEObject) newStereotype).eInverseAdd(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
			msgs = basicSetStereotype(newStereotype, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.MODEL_ELEMENT__STEREOTYPE, newStereotype, newStereotype));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getTaggedValue() {
		if (taggedValue == null) {
			taggedValue = new EObjectContainmentWithInverseEList(TaggedValue.class, this, CorePackage.MODEL_ELEMENT__TAGGED_VALUE, Extension_mechanismsPackage.TAGGED_VALUE__MODEL_ELEMENT);
		}
		return taggedValue;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getBehavior() {
		if (behavior == null) {
			behavior = new EObjectWithInverseResolvingEList(StateMachine.class, this, CorePackage.MODEL_ELEMENT__BEHAVIOR, State_machinesPackage.STATE_MACHINE__CONTEXT);
		}
		return behavior;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getClassifierRole() {
		if (classifierRole == null) {
			classifierRole = new EObjectWithInverseResolvingEList.ManyInverse(ClassifierRole.class, this, CorePackage.MODEL_ELEMENT__CLASSIFIER_ROLE,
					CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS);
		}
		return classifierRole;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getCollaboration() {
		if (collaboration == null) {
			collaboration = new EObjectWithInverseResolvingEList.ManyInverse(Collaboration.class, this, CorePackage.MODEL_ELEMENT__COLLABORATION,
					CollaborationsPackage.COLLABORATION__CONSTRAINING_ELEMENT);
		}
		return collaboration;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getPartition() {
		if (partition == null) {
			partition = new EObjectWithInverseResolvingEList.ManyInverse(Partition.class, this, CorePackage.MODEL_ELEMENT__PARTITION, Activity_graphsPackage.PARTITION__CONTENTS);
		}
		return partition;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.MODEL_ELEMENT__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.MODEL_ELEMENT__NAMESPACE, msgs);
			case CorePackage.MODEL_ELEMENT__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.MODEL_ELEMENT__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__NAMESPACE:
				return eBasicSetContainer(null, CorePackage.MODEL_ELEMENT__NAMESPACE, msgs);
			case CorePackage.MODEL_ELEMENT__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__BINDING:
				return basicSetBinding(null, msgs);
			case CorePackage.MODEL_ELEMENT__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case CorePackage.MODEL_ELEMENT__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CorePackage.MODEL_ELEMENT__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CorePackage.MODEL_ELEMENT__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.MODEL_ELEMENT__ELEMENT_IMPORT:
			return getElementImport();
		case CorePackage.MODEL_ELEMENT__NAME:
			return getName();
		case CorePackage.MODEL_ELEMENT__VISIBILITY:
			return getVisibility();
		case CorePackage.MODEL_ELEMENT__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.MODEL_ELEMENT__NAMESPACE:
			return getNamespace();
		case CorePackage.MODEL_ELEMENT__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CorePackage.MODEL_ELEMENT__CONSTRAINT:
			return getConstraint();
		case CorePackage.MODEL_ELEMENT__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CorePackage.MODEL_ELEMENT__PRESENTATION:
			return getPresentation();
		case CorePackage.MODEL_ELEMENT__TARGET_FLOW:
			return getTargetFlow();
		case CorePackage.MODEL_ELEMENT__SOURCE_FLOW:
			return getSourceFlow();
		case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case CorePackage.MODEL_ELEMENT__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case CorePackage.MODEL_ELEMENT__COMMENT:
			return getComment();
		case CorePackage.MODEL_ELEMENT__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case CorePackage.MODEL_ELEMENT__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case CorePackage.MODEL_ELEMENT__TAGGED_VALUE:
			return getTaggedValue();
		case CorePackage.MODEL_ELEMENT__BEHAVIOR:
			return getBehavior();
		case CorePackage.MODEL_ELEMENT__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CorePackage.MODEL_ELEMENT__COLLABORATION:
			return getCollaboration();
		case CorePackage.MODEL_ELEMENT__PARTITION:
			return getPartition();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.MODEL_ELEMENT__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__NAME:
			setName((String) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.MODEL_ELEMENT__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__BINDING:
			setBinding((Binding) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CorePackage.MODEL_ELEMENT__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.MODEL_ELEMENT__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CorePackage.MODEL_ELEMENT__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CorePackage.MODEL_ELEMENT__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CorePackage.MODEL_ELEMENT__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CorePackage.MODEL_ELEMENT__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CorePackage.MODEL_ELEMENT__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CorePackage.MODEL_ELEMENT__CONSTRAINT:
			getConstraint().clear();
			return;
		case CorePackage.MODEL_ELEMENT__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CorePackage.MODEL_ELEMENT__PRESENTATION:
			getPresentation().clear();
			return;
		case CorePackage.MODEL_ELEMENT__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CorePackage.MODEL_ELEMENT__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case CorePackage.MODEL_ELEMENT__BINDING:
			setBinding((Binding) null);
			return;
		case CorePackage.MODEL_ELEMENT__COMMENT:
			getComment().clear();
			return;
		case CorePackage.MODEL_ELEMENT__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case CorePackage.MODEL_ELEMENT__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case CorePackage.MODEL_ELEMENT__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CorePackage.MODEL_ELEMENT__BEHAVIOR:
			getBehavior().clear();
			return;
		case CorePackage.MODEL_ELEMENT__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CorePackage.MODEL_ELEMENT__COLLABORATION:
			getCollaboration().clear();
			return;
		case CorePackage.MODEL_ELEMENT__PARTITION:
			getPartition().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.MODEL_ELEMENT__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CorePackage.MODEL_ELEMENT__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CorePackage.MODEL_ELEMENT__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case CorePackage.MODEL_ELEMENT__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CorePackage.MODEL_ELEMENT__NAMESPACE:
			return getNamespace() != null;
		case CorePackage.MODEL_ELEMENT__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CorePackage.MODEL_ELEMENT__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CorePackage.MODEL_ELEMENT__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CorePackage.MODEL_ELEMENT__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CorePackage.MODEL_ELEMENT__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CorePackage.MODEL_ELEMENT__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case CorePackage.MODEL_ELEMENT__BINDING:
			return binding != null;
		case CorePackage.MODEL_ELEMENT__COMMENT:
			return comment != null && !comment.isEmpty();
		case CorePackage.MODEL_ELEMENT__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CorePackage.MODEL_ELEMENT__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case CorePackage.MODEL_ELEMENT__STEREOTYPE:
			return stereotype != null;
		case CorePackage.MODEL_ELEMENT__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CorePackage.MODEL_ELEMENT__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CorePackage.MODEL_ELEMENT__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CorePackage.MODEL_ELEMENT__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CorePackage.MODEL_ELEMENT__PARTITION:
			return partition != null && !partition.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: "); //$NON-NLS-1$
		result.append(name);
		result.append(", visibility: "); //$NON-NLS-1$
		result.append(visibility);
		result.append(", isSpecification: "); //$NON-NLS-1$
		result.append(isSpecification);
		result.append(')');
		return result.toString();
	}

} // ModelElementImpl
